% compute the distance between solutions
% test data: solutions = [1 1;2 2; 3 3; 0 0 ];
function result = fDistance(solutions,caseNo)
if nargin<2; caseNo = 2; end
[m,n] = size(solutions);
result = zeros(m,m);
for i = 1:m
    temp = solutions(i,:);
    switch caseNo
        case 1 % techbycheff distance
            data = abs(rep(temp,[m,1])-solutions);
            distance = min(data,[],2);
            result(i,:) = distance';
        case 2 % euclidean distance
            % equal to this function: l2matrix(solutions)
            distance = sqrt(sum((repmat(temp,[m,1])-solutions).^2,2));
            result(i,:) = distance' ;
        case 3 % Lp distance
            % equal to this function: l2matrix(solutions)
            M = size(solutions,2); p = M;
            distance = (sum((rep(temp,[m,1])-solutions).^p,2)).^(1/p);
            result(i,:) = distance' ;
    end
end
